#!/bin/sh
#
# Copyright 2004-2016 RainbowFish Software
#
# PacsOne Server Uninstall Script

basedir=`pwd`;
script="pacsone"
systemctl=`which systemctl`
os=`uname -s`
if test $os = "Darwin"
then
    macos=1
    stopcmd="/sbin/SystemStarter stop \"PacsOne Server Premium Edition\""
else
    macos=0
    if test -d /etc/init.d/
    then
        initdir=/etc/init.d
    else
        initdir=/etc/rc.d
    fi
    if test -x $systemctl
    then
        stopcmd="$basedir/$script stop"
    else
        stopcmd="$initdir/$script stop"
    fi
fi

# Shutdown PacsOne Server
echo "Stopping PacsOne Server..."
$stopcmd
echo "Done."

chkconfig=`which chkconfig`
if test -z $chkconfig
then
    chkconfig="/sbin/chkconfig"
    updatercd=`which update-rc.d`
    if test -z $updatercd
    then updatercd="/usr/sbin/update-rc.d"
    fi
fi
# remove the control script and setup symbolic links in /etc/rc.d/
echo "Removing PacsOne Server Startup Scripts..."
if test $macos -eq 1
then
    rm -rf /Library/StartupItems/$script/$script
    rm -rf /Library/StartupItems/$script/StartupParameters.plist
else
    if test -x $systemctl
        rm -rf /etc/systemd/system/multi-user.target.wants/pacsone.service
        # update service list
        $systemctl daemon-reload
    then
    fi
    if test -x $chkconfig
    then $chkconfig --del $script
    else
      # chkconfig is not available
      if test -x $updatercd
      then
        # run the 'update-rc.d' command to remove the init scripts
        $updatercd -f $script remove
      else
        rm -rf $initdir/rc5.d/S99pacsone
        rm -rf $initdir/rc0.d/K01pacsone
      fi # test -x $updatercd
    fi  # test -x $chkconfig
    rm -rf $initdir/$script
fi
echo "Done."

# remove the PacsOne distribution package
echo "Removing PacsOne Server Distribution Package..."
cd $basedir;cd ..
rm -rf $basedir

echo "PacsOne Server Removed Successfully."
